﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;
using SignalOutputLib;
using Microsoft.Win32;
using System.IO;

namespace PolarisEWinnerAPI_TestAP
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            tabControl1.SelectedIndex = 4;

        }
        EWinner.EWinner_InterfaceClass objEwinner;
        //STCCOrdersClass StccObj;
        //FilledOrdersClass foc;


        private void Form1_Load(object sender, EventArgs e)
        {
            LoadMyReg_TS();

        }
        
        //載入Regedit TS參數
        void LoadMyReg_TS() 
        {
            string strSubKeyPath = "SOFTWARE\\Polaris\\B2CAPI_TS2000i";
            string strReturnKeyValue;
            if (HaveReg(strSubKeyPath))
            {
                strReturnKeyValue = ReadReg(strSubKeyPath, "FutAccount_TS");
                if (!string.IsNullOrEmpty(strReturnKeyValue)) txtFutAccount_TS.Text = strReturnKeyValue;
                strReturnKeyValue = ReadReg(strSubKeyPath, "FutDayTrade_TS");
                if (!string.IsNullOrEmpty(strReturnKeyValue)) chkBoxFutDayTrade_TS.Checked= Convert.ToBoolean(strReturnKeyValue);
                strReturnKeyValue = ReadReg(strSubKeyPath, "FutPosition_TS");
                if (!string.IsNullOrEmpty(strReturnKeyValue)) txtFutPosition_TS.Text = strReturnKeyValue;
                strReturnKeyValue = ReadReg(strSubKeyPath, "Strategy_TS");
                if (!string.IsNullOrEmpty(strReturnKeyValue)) txtStrategy_TS.Text = strReturnKeyValue;
                strReturnKeyValue = ReadReg(strSubKeyPath, "TSSymbol");
                if (!string.IsNullOrEmpty(strReturnKeyValue)) txtTSSymbol.Text = strReturnKeyValue;
                strReturnKeyValue = ReadReg(strSubKeyPath, "FutProductID_TS");
                if (!string.IsNullOrEmpty(strReturnKeyValue)) txtFutProductID_TS.Text = strReturnKeyValue;
                strReturnKeyValue = ReadReg(strSubKeyPath, "FutTradeMonth_TS");
                if (!string.IsNullOrEmpty(strReturnKeyValue)) txtFutTradeMonth_TS.Text = strReturnKeyValue;
                strReturnKeyValue = ReadReg(strSubKeyPath, "FutOdrQty_TS");
                if (!string.IsNullOrEmpty(strReturnKeyValue)) comboBoxFutOdrQty_TS.Text = strReturnKeyValue;
                strReturnKeyValue = ReadReg(strSubKeyPath, "FutOdrFlag_TS");
                if (!string.IsNullOrEmpty(strReturnKeyValue) && (strReturnKeyValue == "M")) radioBtnFutOrderFlag2_TS.Checked = true;
                strReturnKeyValue = ReadReg(strSubKeyPath, "FutMarketFlag");
                if (!string.IsNullOrEmpty(strReturnKeyValue) && (strReturnKeyValue == "A")) radioBtn_futMarket2.Checked = true;

           }
        
        }
        
        //回存Regedit TS參數
        void SaveMyReg_TS()
        {
            string strSubKeyPath = "SOFTWARE\\Polaris\\B2CAPI_TS2000i";

            WriteReg(strSubKeyPath, "FutAccount_TS", txtFutAccount_TS.Text);
            if(chkBoxFutDayTrade_TS.Checked)
                WriteReg(strSubKeyPath, "FutDayTrade_TS", "true");
            else
                WriteReg(strSubKeyPath, "FutDayTrade_TS", "false");
            WriteReg(strSubKeyPath, "FutPosition_TS", txtFutPosition_TS.Text);
            WriteReg(strSubKeyPath, "Strategy_TS", txtStrategy_TS.Text);
            WriteReg(strSubKeyPath, "TSSymbol", txtTSSymbol.Text);
            WriteReg(strSubKeyPath, "FutProductID_TS", txtFutProductID_TS.Text);
            WriteReg(strSubKeyPath, "FutTradeMonth_TS", txtFutTradeMonth_TS.Text);
            WriteReg(strSubKeyPath, "FutOdrQty_TS", comboBoxFutOdrQty_TS.Text);
            //委託價格Flag
            if (radioBtnFutOrderFlag2_TS.Checked)
                WriteReg(strSubKeyPath, "FutOdrFlag_TS", "M");  //市價
            else
                WriteReg(strSubKeyPath, "FutOdrFlag_TS", "L");  //限價
            //市場Flag
            if (radioBtn_futMarket.Checked)
                WriteReg(strSubKeyPath, "FutMarketFlag", "F");  //國內期貨
            else
                WriteReg(strSubKeyPath, "FutMarketFlag", "A");  //國際期貨

        }


        void so_Add(List<string> info)
        {
            string strOrderString = "";
            string strBSFlag = "";
            int intPosition = Convert.ToInt32(txtFutPosition_TS.Text);
            int intOrderQty = Convert.ToInt32(comboBoxFutOdrQty_TS.Text);
            double dblOrderPrice;
            int intDenominator; //分母

            //new Thread((ThreadStart)delegate()
            //{
            //txtBox_TSAlert.AppendText(info.Count.ToString());  

            if (radioBtn_futMarket.Checked) //國內期貨
                intDenominator = 1;
            else                           //國際期貨 
                intDenominator = 10000;    //行情報價送過來 12330 變成123300000, 所以要除10000

            txtBox_TSAlert.AppendText(string.Join(",#", info.ToArray()));
            txtBox_TSAlert.AppendText(Environment.NewLine);
            
            if (info.Count >= 12)
            {
                if ((info[0] == this.txtTSSymbol.Text) && (info[7].Trim() == this.txtStrategy_TS.Text.Trim()))
                {
                    dblOrderPrice = Convert.ToDouble(info[3].Trim()) / intDenominator;

                    switch(info[1])
                    {
                        case "SE": //空單進場
                            if (intPosition >= 0)   //部位有多單 or 無部位
                            {
                                strBSFlag = "S";
                                if (intPosition > 0) intOrderQty = intOrderQty * 2; //部位有多單->反向2倍空單
                            }
                            if (radioBtnFutOrderFlag_TS.Checked) dblOrderPrice = dblOrderPrice - Convert.ToDouble(txtFutOverPrice_TS.Text);
                            break;

                        case "LX": //多單出場
                            if (intPosition > 0) strBSFlag = "S";   //部位有多單時才執行多單出場
                            if (radioBtnFutOrderFlag_TS.Checked) dblOrderPrice = dblOrderPrice - Convert.ToDouble(txtFutOverPrice_TS.Text);
                            break;

                        case "SX": //空單出場
                            if (intPosition < 0) strBSFlag = "B";   //部位有空單時才執行空單出場
                            if (radioBtnFutOrderFlag_TS.Checked) dblOrderPrice = dblOrderPrice + Convert.ToDouble(txtFutOverPrice_TS.Text);
                            break;

                        case "LE": //多單進場
                            if (intPosition <= 0)   //部位有空單 or 無部位
                            {
                                strBSFlag = "B";
                                if (intPosition < 0) intOrderQty = intOrderQty * 2; //部位有空單->反向2倍多單
                            }
                            if (radioBtnFutOrderFlag_TS.Checked) dblOrderPrice = dblOrderPrice + Convert.ToDouble(txtFutOverPrice_TS.Text);
                            break;
                    }


                    if (!String.IsNullOrEmpty(strBSFlag))
                    {
                        StringBuilder sb = new StringBuilder();
                        sb.Append("Account=");
                        sb.Append(txtFutAccount_TS.Text.Trim());
                        sb.Append(",ProductID=");
                        sb.Append(txtFutProductID_TS.Text.Trim());
                        sb.Append(txtFutTradeMonth_TS.Text.Trim());
                        sb.Append(",BuySell=");
                        sb.Append(strBSFlag);
                        sb.Append(",Qty=");
                        sb.Append(intOrderQty.ToString());

                        if (radioBtnFutOrderFlag2_TS.Checked)   //市價
                        {
                            if (radioBtn_futMarket.Checked) //國內期貨
                                sb.Append(", Price=M");
                            else                           //國際期貨
                                sb.Append(",PriceType=MTK");        
                                
                        }
                        else    //限價 (非分數型態商品)
                        {
                            sb.Append(", Price=");
                            sb.Append(dblOrderPrice.ToString());

                            if (radioBtn_futMarket2.Checked) //國際期貨
                            {
                                sb.Append(",PriceType=LMT");        
                            }
                        }

                        if (chkBoxFutDayTrade_TS.Checked) sb.Append(", DayTrade=Y");
                        strOrderString = sb.ToString();

                        //Write 送單紀錄
                        txtBox_OrderHistory.AppendText(DateTime.Now.ToString("[HH:mm:ss.fff] ")+strOrderString);
                        txtBox_OrderHistory.AppendText(Environment.NewLine);
                        
                        //計算TS部位
                        if (chkBoxCalPositonFlag_TS.Checked)
                        {
                            if (strBSFlag == "B")
                            {
                                txtFutPosition_TS.Text = Convert.ToString(intPosition + intOrderQty);
                            }
                            else
                            {
                                txtFutPosition_TS.Text = Convert.ToString(intPosition - intOrderQty);
                            }
                        }
                        

                        //Send Order
                        if(chkBoxSendOrderFlag_TS.Checked)
                        {
                            try
                            {
                                string strProuductType;
                                if (radioBtn_futMarket.Checked)
                                     strProuductType = "F";    //國內期貨
                                else
                                     strProuductType = "A";    //國際期貨

                                objEwinner.SendOrder(strProuductType, strOrderString);
                            }
                            catch (Exception ex)
                            {
                                DisplayResult("期貨下單失敗!!\r\n");
                            }

                        }

                    }
                }

            }
              
                
            //}).Start();
        }

        

        //void foc_IFilledEvents_Event_Add(object pDisp)
        //{
        //    throw new Exception("The method or operation is not implemented.");
        //}
        private void btnStart_Click(object sender, EventArgs e)
        {
            try
            {
                objEwinner = new EWinner.EWinner_InterfaceClass();
                objEwinner.OnDataResponse += new EWinner.IEWinner_InterfaceEvents_OnDataResponseEventHandler(objEwinner_OnDataResponse);
                
                System.Threading.Thread.Sleep(500);
                try
                {
                    objEwinner.SetOpen(1);
                }
                catch (Exception ex)
                {
                    DisplayResult("開啟API下單失敗\r\n");
                }

            }
            catch (Exception ex)
            {
                DisplayResult( "請先開啟點金靈環球通\r\n");
            }
        }

        //void objEwinner_OnDataResponse(int Index, object Value)
        //{
        //    throw new Exception("The method or operation is not implemented.");
        //}

        void objEwinner_OnDataResponse(int Index, object Value)
        {
            try
            {
                DisplayResult(Index.ToString() + " : " + Convert.ToString(Value).Trim() + "\r\n");
            }
            catch (Exception ex)
            {
                DisplayResult(ex.ToString() + "\r\n");
            }
        }
        private void DisplayResult(string strResult)
        {
            try
            {
                if (InvokeRequired)
                {
                    BeginInvoke(new Action<string>(DisplayResult), strResult);
                    return;
                }
                this.textBox1.Text += strResult;
            }
            catch (Exception ex)
            {
                this.textBox1.Text += "回傳事件建立失敗 \r\n";
            }
        }

        //private void btnOpenAPIOrder_Click(object sender, EventArgs e)
        //{
        //    try
        //    {
        //        objEwinner.SetOpen(1);
        //    }
        //    catch (Exception ex)
        //    {
        //        DisplayResult("開啟API下單失敗\r\n");
        //    }
        //}

        //private void btnCloseAPIOrder_Click(object sender, EventArgs e)
        //{
        //    try
        //    {
        //        objEwinner.SetOpen(0);   //關閉API下單功能
        //        //Marshal.ReleaseComObject(objEwinner);  //釋放此API所佔用資源
        //        //chkBoxSendOrderFlag_TS.Checked = false;
        //    }
        //    catch (Exception ex)
        //    {
        //        DisplayResult("關閉API下單失敗\r\n");
        //    }
        //}

        private void btnSendAPIOrder_Click(object sender, EventArgs e)
        {
            try
            {
                objEwinner.SendOrder("S", "Account=" + this.txtStkAccount.Text.Trim() + ",ProductID=" + this.txtStkProductID.Text.Trim() + ",TradeType=" + this.txtStkTradeType.Text.Trim() + ", TradeKind=" + this.txtStkTradeKind.Text.Trim() + ", OrderType=" + this.txtStkOrderType.Text.Trim() + ", BuySell=" + this.txtStkBuySell.Text.Trim() + ", Qty=" + this.txtStkQty.Text.Trim() + ", Price=" + this.txtStkPrice.Text.Trim() + ", OrderNo=" + this.txtStkOrderNo.Text.Trim() + ", TradeDate=" + this.txtStkTradeDate.Text.Trim() + ", BasketNo=" + this.txtStkBasketNo.Text.Trim());
            }
            catch (Exception ex)
            {
                DisplayResult("現貨下單失敗!!\r\n");
            }
        }

        private void btnFutOrder_Click(object sender, EventArgs e)
        {
            try
            {
                string strProuductType = "";
                if (this.txtFutProductID.Text.Trim().Substring(0, 1).ToUpper() == "F")
                {

                    strProuductType = "F";
                }
                else
                {
                    strProuductType = "O";
                }
                objEwinner.SendOrder(strProuductType, "Account=" + this.txtFutAccount.Text.Trim() + ",ProductID=" + this.txtFutProductID.Text.Trim() + ", BuySell=" + this.txtFutBuySell.Text.Trim() + ",ProductID2=" + this.txtFutProductID2.Text.Trim() + ", BuySell2=" + this.txtFutBuySell2.Text.Trim() + ", Qty=" + this.txtFutQty.Text.Trim() + ", Price=" + this.txtFutPrice.Text.Trim() + ",PositionEffect=" + this.txtFutPositionEffect.Text.Trim() + ", DayTrade=" + this.txtFutDayTrade.Text.Trim() + ", OrderCond=" + this.txtFutOrderCond.Text.Trim() + ", OrderNo=" + this.txtFutOrderNo.Text.Trim() + ", TradeDate=" + this.txtFutTradeDate.Text.Trim() + ", BasketNo=" + this.txtFutBasketNo.Text.Trim());
            }
            catch (Exception ex)
            {
                DisplayResult("期貨下單失敗!!\r\n");
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
                objEwinner.SendOrder("S", "Account=" + this.txtEmgAccount.Text.Trim() + ",ProductID=" + this.txtEmgProductID.Text.Trim() + ", TradeKind=" + this.txtEmgTradeKind.Text.Trim() + ", BuySell=" + this.txtEmgBuySell.Text.Trim() + ", Qty=" + this.txtEmgQty.Text.Trim() + ", Price=" + this.txtEmgPrice.Text.Trim() + ", OrderNo=" + this.txtEmgOrderNo.Text.Trim() + ", TradeDate=" + this.txtEmgTradeDate.Text.Trim() );
            }
            catch (Exception ex)
            {
                DisplayResult("興櫃下單失敗!!\r\n");
            }
        }

        private void btnOVOrder_Click(object sender, EventArgs e)
        {
            
            try
            {
                objEwinner.SendOrder("V", "Account=" + this.txtOVAccount.Text.Trim() + ",MarketNo=" + this.txtOVMarketNo.Text.Trim() + ",ProductID=" + this.txtOVProductID.Text.Trim() + ", TradeKind=" + this.txtOVTradeKind.Text.Trim() + ", BuySell=" + this.txtOVBuySell.Text.Trim() + ", Qty=" + this.txtOVQty.Text.Trim() + ", Price=" + this.txtOVPrice.Text.Trim() + ", OrderNo=" + this.txtOVOrderNo.Text.Trim() );
            }
            catch (Exception ex)
            {
                DisplayResult("國外股票下單失敗!!\r\n");
            }
        }


        //private void button4_Click(object sender, EventArgs e)
        //{
        //    SignalOutput so = new SignalOutput();
        //    so.Add += new SignalOutput.AddEventHandler(so_Add);
        //}

        private void btnGetTSInfo_Click(object sender, EventArgs e)
        {
            SignalOutput so = new SignalOutput();
            so.Add += new SignalOutput.AddEventHandler(so_Add);
        }

        //private void button4_Click(object sender, EventArgs e)
        //{
        //    string[] a = StringSplit(txtTestMsg.Text,",#");
        //    List<string> b = new List<string>(a);
        //    so_Add(b);
        //}

        #region function

        /// <summary>
        /// split string字串
        /// </summary>
        /// <param name="strData">原始字串</param>
        /// <param name="str_Separtor">split字串</param>
        /// <returns>string[]</returns>
        public string[] StringSplit(string strData, string str_Separtor)
        {
            //strData = DelimiterEndFilter(strData, str_Separtor);
            int separtor_len = str_Separtor.Length;
            List<string> DataArray = new List<string>();
            bool search_flag = true;
            while (search_flag) 
            {
                int findIndex = strData.IndexOf(str_Separtor);  
                if (findIndex >= 0)
                {
                    DataArray.Add(strData.Substring(0, findIndex));
                    strData = strData.Remove(0, findIndex + separtor_len);
                }
                else
                {
                    DataArray.Add(strData);
                    search_flag = false;
                }
            }
            string[] str_ary_Data = new string[DataArray.Count];
            DataArray.CopyTo(str_ary_Data, 0);
            return str_ary_Data;
        }

        /// 
        /// 讀取 Regedit
        /// 
        /// 機碼路徑
        /// key name
        /// string
        public static string ReadReg(string SubKeyPath, string keyName)
        {
            string strkeyValue = "";

            try
            {
                RegistryKey rootkey = Registry.CurrentUser; //Registry參數
                RegistryKey subKey = rootkey.OpenSubKey(SubKeyPath);
                strkeyValue = subKey.GetValue(keyName).ToString();
                subKey.Close();
                rootkey.Close();

            }
            catch (Exception)
            {
                //throw;
            }
            return strkeyValue;
        }

        /// 
        /// 判斷 Regedit 是否存在
        /// 
        /// 機碼路徑
        /// bool 
        public static bool HaveReg(string SubKeyPath)
        {
            bool bolReturnValue = false;
            try
            {
                RegistryKey rootKey = Registry.CurrentUser;
                RegistryKey subKey = rootKey.OpenSubKey(@SubKeyPath);

                //不存在
                if (subKey == null)
                {
                    bolReturnValue = false;
                }
                else
                {
                    bolReturnValue = true;
                }
                subKey.Close();
                rootKey.Close();

            }
            catch (Exception)
            {
                //throw;
            }
            return bolReturnValue;
        }

        /// 
        /// 寫入 Regedit
        /// 
        /// 機碼路徑
        /// key名稱
        /// key值 
        /// bool
        public static bool WriteReg(string SubKeyPath, string keyName, string keyValue)
        {
            bool bolReturnValue = false;
            try
            {
                RegistryKey rootKey = Registry.CurrentUser;
                RegistryKey subKey = rootKey.OpenSubKey(@SubKeyPath);

                //不存在,Create 
                if (subKey == null)
                {
                    rootKey.CreateSubKey(SubKeyPath);
                }

                //寫入資料
                subKey = rootKey.OpenSubKey(SubKeyPath, true);
                subKey.SetValue(keyName, keyValue);
                bolReturnValue = true;
                subKey.Close();
                rootKey.Close();


            }
            catch (Exception)
            {
                //throw;
            }
            return bolReturnValue;

        }

        #endregion

  
        private void chkBoxCalPositonFlag_TS_Click(object sender, EventArgs e)
        {
            if (Convert.ToInt32(txtFutPosition_TS.Text) % Convert.ToInt32(comboBoxFutOdrQty_TS.Text) == 0)
            {
                if (chkBoxCalPositonFlag_TS.Checked)
                {
                    txtFutPosition_TS.Enabled = false;
                    comboBoxFutOdrQty_TS.Enabled = false;
                }
                else
                {
                    txtFutPosition_TS.Enabled = true;
                    comboBoxFutOdrQty_TS.Enabled = true;
                }
            }
            else
            {
                //txtFutPosition_TS.Enabled = false;
                chkBoxCalPositonFlag_TS.Checked = false;
                MessageBox.Show("下單口數與部位數要整除!");
            }
        }

        private void chkBoxSendOrderFlag_TS_Click(object sender, EventArgs e)
        {
            if (chkBoxSendOrderFlag_TS.Checked)
            {
                try
                {
                    objEwinner.SetOpen(1);
                }
                catch (Exception ex)
                {
                    DisplayResult("開啟API下單失敗\r\n");
                    chkBoxSendOrderFlag_TS.Checked = false;
                }
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            SaveMyReg_TS(); //儲存TS 參數到regedit
            try
            {
                //objEwinner.SetOpen(0);   //關閉API下單功能
                Marshal.ReleaseComObject(objEwinner);  //釋放此API所佔用資源
            }
            catch (Exception ex)
            {
                //DisplayResult("關閉API下單失敗\r\n");
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
          //  MessageBox.Show("close?");
        }

        private void btnSaveTSAlert_Click(object sender, EventArgs e)
        {
            //txtBox_TSAlert.Text
            string path = "TS_Msg" + DateTime.Now.ToString("_yyyyMMdd-HHmmss.fff") + ".txt";   //檔案路徑
            Encoding unicode = Encoding.GetEncoding(950);//使用中文
            if (!File.Exists(path))//檔案是否存在
            {
                // 如果檔案不存在則建立新檔
                File.WriteAllText(path, txtBox_TSAlert.Text);
            }
        }

     

  
        

    }
}